#ifndef K_STRUCTURE_H
#define K_STRUCTURE_H


//--------------------------------------------------------------------------
/* +
 *  
 *
 *  ChessTerminator75
 *   27.11.2007
*/
//--------------------------------------------------------------------------

// Bitboard

//    
const int NAME = 7;
//        
const int COORDINATE = 64;
//  
struct T_Bitboard {
//-------------------------------------------------
//    
//A8(56) B8(57) C8(58) D8(59) E8(60) F8(61) G8(62) H8(63)
//A7(48) B7(49) C7(50) D7(51) E7(52) F7(53) G7(54) H7(55)
//A6(40) B6(41) C6(42) D6(43) E6(44) F6(45) G6(46) H6(47)
//A5(32) B5(33) C5(34) D5(35) E5(36) F5(37) G5(38) H5(39)
//A4(24) B4(25) C4(26) D4(27) E4(28) F4(29) G4(30) H4(31)
//A3(16) B3(17) C3(18) D3(19) E3(20) F3(21) G3(22) H3(23)
//A2(8)  B2(9)  C2(10) D2(11) E2(12) F2(13) G2(14) H2(15)
//A1(0)  B1(1)  C1(2)  D1(3)  E1(4)  F1(5)  G1(6)  H1(7)
//
//A1(MSB)-    H8(LSB)- 63 
// ..     
// H8(63) G8(62) F8(61) . . . . . .C1(2) B1(1) A1(0)
//-------------------------------------------------
// 
//   64           
//             
//            
//     
unsigned __int64  all_piece;
unsigned __int64  all_white_piece;
unsigned __int64  all_black_piece;

//-------------------------------------------------
//  
/*
  
 0 -  
 1 -  
 2 -  
 3 - 
 4 -  
 5 -  
 6 - 
*/
//      
unsigned __int64 white_piece[NAME];
unsigned __int64 black_piece[NAME];

//     
int white_name_from_coord[COORDINATE];
int black_name_from_coord[COORDINATE];

//-------------------------------------------------
//  
//   0 -  1 - 
int  colour_move;

//     1/0
int  taking_passage_yes;
//    (  ) 
int  taking_passage_x;
//    (     ) 
int  taking_passage_y;

//        1/0
int  castling_Q;
//       1/0
int  castling_K;
//       1/0
int  castling_q;
//      1/0
int  castling_k;

//   (?   int )
int hash_key ;
//  
int eval ;
};//struct T_Bitboard {






///////////////////////////////////////////////////////////////////////////////////

//    1201 + 6
//#define DELTA(d) (1+(d))          

//  
//Integer.         4bytes            signed: -2147483648 to 2147483647
//                                   unsigned:         0 to 4294967295 
//   
//Short Integer.   2bytes            signed:      -32768 to 32767
//                                   unsigned:         0 to 65535 

//const int MAX_MOVES = 80000000;
//                    
const int MAX_MOVES = 250000;
const int MAX_DEPTH = 100;

//    char signed: -128 to 127
//---------------------------------------------------------------------------
//    1201 + 6
struct T_list_surplus_moves {
////////////////////////////////////////////////////////////////////////////
//     :  :  , ,    
//    ,  .
//   short int ~+-32000

//  : 0 - ,1 -  2 -  3 -  4 -  5 -  6 -  
short int name_figure[MAX_MOVES];

//   (  )
short int  initial_position[MAX_MOVES]; 

//   (  )
short int  final_position[MAX_MOVES];

//     0,  1,    2,  3,
//    4,   5,   6,   7,
//      8,     9,
//      10,     11,
short int  description_move[MAX_MOVES];

//      
short int  start_list[MAX_DEPTH];

//      
short int  end_captures[MAX_DEPTH];

//      
short int  end_list[MAX_DEPTH];
/*
:
0
1  
2  
3 
4
start_list  1
end_list    4
*/

//  
short int  current_depth;


////////////////////////////////////////////////////////////////////////////

//          

//    0 - ,1 -  2 -  3 -  4 -  5 -  6 -  
short int  name_taking_figure[MAX_MOVES];
//      1/0
short int  return_taking_passage[MAX_DEPTH];
//      
short int  return_castling_Q[MAX_DEPTH];
//      
short int  return_castling_K[MAX_DEPTH];
//      
short int  return_castling_q[MAX_DEPTH];
//      
short int  return_castling_k[MAX_DEPTH];

};//struct T_list_surplus_moves {

//---------------------------------------------------------------------------
//   :
//  0  1  2  3  4  5  6  7   8  9  10 11 12 13 14 15 
//  16 17 18 19 20 21 22 23  24 25 26 27 28 29 30 31 
//  32 33 34 35 36 37 38 39  40 41 42 43 44 45 46 47 
//  48 49 50 51 52 53 54 55  56 57 58 59 60 61 62 63 
//  64 65 66 67 68 69 70 71  72 73 74 75 76 77 78 79 
//  80 81 82 83 84 85 86 87  88 89 90 91 92 93 94 95 
//  96 97 98 99 00 01 02 03  04 05 06 07 08 09 10 11 
//  12 13 14 15 16 17 18 19  20 21 22 23 24 25 26 27 
// 8  16 = 128
// x = 0..7 n&15  n/16
// y = 0..7 n>>4  n%16
// n = y*16 + x

//     8  16
struct T_board_list_816 {
//   0 -  1 -  2 - 
short int  colour_move;
//    0 - , 1 - , 2 - , 3 - , 4 - , 5 - , 6 - 
short int  name_figure_816[128];
//    0 - , 1 - , 2 - , 3 -    
short int  colour_figure_816[128];

//   
int hash_key ;

//  
int eval ;

//     1/0
short int  taking_passage_yes;
//    (  ) 
short int  taking_passage_x;
//    (     ) 
short int  taking_passage_y;
//     
short int  castling_Q;
//     
short int  castling_K;
//     
short int  castling_q;
//     
short int  castling_k;
};//struct T_board_list_816 {

//---------------------------------------------------------------------------
//   (    32  + 40   = 72)
struct T_PV {
////   (  )
short int  initial_position[70]; 
//   (  )
short int  final_position[70];
//    0 -  2 -  3 -  4 -  5 -  
short int  final_pawn[70];

//  
int score_move;
//  
short int  depth_max;
};//struct T_PV {

//---------------------------------------------------------------------------
//       
struct T_hash_moves {
//   
int key;

//   (  )
short int  initial_position; 

//   (  )
short int  final_position;

//    
short int  depth;
};//struct T_PV {

//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//   - 
struct T_killer_moves {

//   (  )
short int  initial_position; 

//   (  )
short int  final_position;

};//struct T_killer_moves {

//---------------------------------------------------------------------------


#endif // !defined D_STRUCTURE_H






